<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class crmGrupoOperadorController extends TeknisaCrud {
    
    protected $dataSourceName = 'CRM_FILATENDIMENTO';
    protected $entityManager;
    protected $connection;
    protected $environment;

    
    public function __construct ($crudService, $parameterBag, $entityManager, $environment)
    {
        $this->entityManager = $entityManager;
        $this->connection    = $entityManager->getConnection();
        $this->environment   = $environment;

        parent::__construct($crudService, $parameterBag);
    }
    
    public function saveOperador(Request $request, Response $response){
        $dataset = $request->getDataSet()->getRows();
        $grupo = $dataset[0]["grupo"];
        $operadores = $dataset[0]["operador"];
        
        
        foreach($operadores as $operador) {
        
        $dataset[0]['operador']['NRSEQRELACOPERADORFILA'] =  NovoCodigo::geraCodigo($this->environment->getNrOrgTrab(), "CRM_RELACOPERADORFILA", 1, 10, false, false);
        
        
            $insertOperadorGrupo = "INSERT INTO CRM_RELACOPERADORFILA (NRORG ,NRSEQRELACOPERADORFILA, NRFILAATENDIMENTO, CDOPERADORRELACIONADO)
             VALUES (:NRORG,
                     :NRSEQRELACOPERADORFILA,
                     :NRFILAATENDIMENTO,
                     :CDOPERADORRELACIONADO)";
                    
            $params = array
            (
                     "NRORG"                    => $grupo["NRORG"],
                     "NRSEQRELACOPERADORFILA"   => $dataset[0]['operador']['NRSEQRELACOPERADORFILA'],
                     "NRFILAATENDIMENTO"        => $grupo["NRFILAATENDIMENTO"],
                     "CDOPERADORRELACIONADO"    => $operador
                );
    
            try
            {
                $std = $this->entityManager->getConnection()->prepare($insertOperadorGrupo);
                $std->execute($params);
            }
            catch(\Exception $e)
            {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };
        }
       
    }
    
    public function excluirGrupo($grupo){
       $deleteGrupo = "DELETE CRM_FILATENDIMENTO
	                    WHERE NRFILAATENDIMENTO = :NRFILAATENDIMENTO
	                      AND NRORG            = :NRORG";
                    
         $params = array
	        (
	            "NRORG"                 => $grupo["NRORG"],
	            "NRFILAATENDIMENTO"     => $grupo["NRFILAATENDIMENTO"]
            );
            
        try
        {
            $std = $this->entityManager->getConnection()->prepare($deleteGrupo);
            $std->execute($params);
        }
        catch(\Exception $e)
        {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        };    
    }
    
    public function excluirGrupoOperador(Request $request, Response $response){
        $grupoer = $request->getRow();
    
        $deleteOperadordoGrupo = "DELETE CRM_RELACOPERADORFILA
	                    WHERE NRFILAATENDIMENTO = :NRFILAATENDIMENTO
	                      AND NRORG            = :NRORG";

	        $params = array
	        (
	            "NRORG"                 => $grupoer["NRORG"],
	            "NRFILAATENDIMENTO"     => $grupoer["NRFILAATENDIMENTO"]
            );

	        try
	        {
	            $std = $this->connection->prepare($deleteOperadordoGrupo);
	            $std->execute($params);
	            self::excluirGrupo($grupoer);
	        }catch (\Exception $e)
	        {
	            throw $e;
	        }
        
    }
    
}





